using System;
using System.Collections.Generic;
using System.Text;
using Spring.Data.NHibernate.Support;
using Guushuuse.SalaryPrj.Security.DomainModel;
using System.Collections;
using Spring.Transaction.Interceptor;
using Spring.Dao.Support;

namespace Guushuuse.SalaryPrj.Security.Dao
{
    /// <summary>
    /// Ӧóݷ
    /// </summary>
    public class ApplicationDao : HibernateDaoSupport, IApplicationDao
    {
        public ApplicationDao()
        {

        }

        [Transaction(ReadOnly = false)]
        public void CreateApplication(Application application)
        {
            HibernateTemplate.Save(application);
        }

        [Transaction(ReadOnly = false)]
        public void UpdateApplication(Application application)
        {
            HibernateTemplate.Update(application);
        }

        [Transaction(ReadOnly = false)]
        public void DeleteApplication(Application application)
        {
            HibernateTemplate.Delete(application);
        }

        public IList GetAllApplications()
        {
            return HibernateTemplate.LoadAll(typeof(Application));
        }

        public Application GetApplication(int applicationID)
        {
            return (Application)HibernateTemplate.Get(typeof(Application), applicationID);
        }

        public Application GetApplication(string applicationName)
        {
            string hql = " from Application application where application.Name = ?";

            IList applications = HibernateTemplate.Find(hql, new object[] { applicationName });

            if (applications.Count > 0)
            {
                return (Application)DataAccessUtils.RequiredUniqueResultSet(applications);
            }
            else
            {
                return null;
            }
        }
    }
}
