﻿using System;
using Guushuuse.SalaryPrj.Security.DomainModel;
using System.Collections;

namespace Guushuuse.SalaryPrj.Security.Dao
{
    /// <summary>
    /// 用户数据访问接口
    /// </summary>
    public interface IUserDao
    {
        void CreateUser(User user);
        void DeleteUser(User user);
        IList FindUsersByEmail(Application application, string emailToMatch, int pageIndex, int pageSize, out int totalRecords);
        IList FindUsersByEmail(Application application, string emailToMatch);
        IList FindUsersByName(Application application, string usernameToMatch);
        IList FindUsersByName(Application application, string usernameToMatch, int pageIndex, int pageSize, out int totalRecords);
        IList FindUsersInRole(Application application, Role role, string usernameToMatch);
        int GetActiveUsersCount(Application application, DateTime activeDate);
        IList GetAllUsers();
        IList GetInactiveUsers(Application application, DateTime userInactiveSinceDate);
        IList GetInactiveUsers(Application application, DateTime userInactiveSinceDate, bool isAnonymous);
        User GetUser(int userID);
        User GetUser(Application application, string username);
        IList GetUsers(Application application, int pageIndex, int pageSize, out long totalRecords);
        IList GetUsers(Application application, string email);
        int GetUsersCountInRole(Application application, Role role);
        IList GetUsersInRole(Application application, Role role);
        void UpdateUser(User user);
    }
}
