using System;
using System.Collections.Generic;
using System.Text;
using Spring.Data.NHibernate.Support;
using Spring.Transaction.Interceptor;
using Guushuuse.SalaryPrj.Security.DomainModel;
using System.Collections;
using Spring.Dao.Support;

namespace Guushuuse.SalaryPrj.Security.Dao
{
    /// <summary>
    /// ɫݷ
    /// </summary>
    public class RoleDao : HibernateDaoSupport, IRoleDao
    {
        public RoleDao()
        {

        }

        [Transaction(ReadOnly = false)]
        public void CreateRole(Role role)
        {
            HibernateTemplate.Save(role);
        }

        [Transaction(ReadOnly = false)]
        public void UpdateRole(Role role)
        {
            HibernateTemplate.Update(role);
        }

        [Transaction(ReadOnly = false)]
        public void DeleteRole(Role role)
        {
            HibernateTemplate.Delete(role);
        }

        public IList GetAllRoles()
        {
            return HibernateTemplate.LoadAll(typeof(Role));
        }

        public IList GetRoles(Application application)
        {
            string hql = " from Role r where r.Application = ?";

            return HibernateTemplate.Find(hql, new object[] { application });
        }

        public Role GetRole(int roleID)
        {
            return (Role)HibernateTemplate.Get(typeof(Role), roleID);
        }

        public Role GetRole(Application application, string roleName)
        {
            string hql = " from Role role where role.Application = ? and role.Name = ?";

            IList roles = HibernateTemplate.Find(hql, new object[] { application, roleName });

            if (roles.Count > 0)
            {
                return (Role)DataAccessUtils.RequiredUniqueResultSet(roles);
            }
            else
            {
                return null;
            }
        }
    }
}
