using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Web.Security;

namespace Guushuuse.SalaryPrj.Security.DomainModel
{
    /// <summary>
    /// û
    /// </summary>
    [Serializable]
    public class User
    {
        private int _id;
        private string _username;
        private string _email;
        private string _password;
        private MembershipPasswordFormat _passwordFormat;
        private string _passwordSalt;
        private string _passwordQuestion;
        private string _passwordAnswer;
        private bool _isAnonymous;
        private bool _isApproved;
        private bool _isLockedOut;
        private DateTime _createDate;
        private DateTime _lastActivityDate;
        private DateTime _lastLoginDate;
        private DateTime _lastPasswordChangedDate;
        private DateTime _lastLockoutDate;
        private int _failedPasswordAttemptCount;
        private DateTime _failedPasswordAttemptWindowStart;
        private int _failedPasswordAnswerAttemptCount;
        private DateTime _failedPasswordAnswerAttemptWindowStart;
        private string _comment;
        private Application _application;
        private IList _roles;

        #region 

        /// <summary>
        /// Զ
        /// </summary>
        public virtual int ID
        {
            get { return _id; }
            set { _id = value; }
        }

        /// <summary>
        /// ¼
        /// </summary>
        public virtual string Username
        {
            get { return _username; }
            set { _username = value; }
        }

        /// <summary>
        /// ʼַ
        /// </summary>
        public virtual string Email
        {
            get { return _email; }
            set { _email = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public virtual string Password
        {
            get { return _password; }
            set { _password = value; }
        }

        /// <summary>
        /// ʽ
        /// </summary>
        public virtual MembershipPasswordFormat PasswordFormat
        {
            get { return _passwordFormat; }
            set { _passwordFormat = value; }
        }

        /// <summary>
        /// ֤
        /// </summary>
        public virtual string PasswordSalt
        {
            get { return _passwordSalt; }
            set { _passwordSalt = value; }
        }

        /// <summary>
        /// ʾ
        /// </summary>
        public virtual string PasswordQuestion
        {
            get { return _passwordQuestion; }
            set { _passwordQuestion = value; }
        }

        /// <summary>
        /// ʾ
        /// </summary>
        public virtual string PasswordAnswer
        {
            get { return _passwordAnswer; }
            set { _passwordAnswer = value; }
        }

        /// <summary>
        /// Ƿû
        /// </summary>
        public virtual bool IsAnonymous
        {
            get { return _isAnonymous; }
            set { _isAnonymous = value; }
        }

        /// <summary>
        /// ǷԽ֤
        /// </summary>
        public virtual bool IsApproved
        {
            get { return _isApproved; }
            set { _isApproved = value; }
        }

        /// <summary>
        /// Ƿ޷֤
        /// </summary>
        public virtual bool IsLockedOut
        {
            get { return _isLockedOut; }
            set { _isLockedOut = value; }
        }

        /// <summary>
        /// ںʱ
        /// </summary>
        public virtual DateTime CreateDate
        {
            get { return _createDate; }
            set { _createDate = value; }
        }

        /// <summary>
        /// һν֤Ӧóںʱ
        /// </summary>
        public virtual DateTime LastActivityDate
        {
            get { return _lastActivityDate; }
            set { _lastActivityDate = value; }
        }

        /// <summary>
        /// һν֤ںʱ
        /// </summary>
        public virtual DateTime LastLoginDate
        {
            get { return _lastLoginDate; }
            set { _lastLoginDate = value; }
        }

        /// <summary>
        /// һθںʱ
        /// </summary>
        public virtual DateTime LastPasswordChangedDate
        {
            get { return _lastPasswordChangedDate; }
            set { _lastPasswordChangedDate = value; }
        }

        /// <summary>
        /// һںʱ
        /// </summary>
        public virtual DateTime LastLockoutDate
        {
            get { return _lastLockoutDate; }
            set { _lastLockoutDate = value; }
        }

        /// <summary>
        /// Դ
        /// </summary>
        public virtual int FailedPasswordAttemptCount
        {
            get { return _failedPasswordAttemptCount; }
            set { _failedPasswordAttemptCount = value; }
        }

        /// <summary>
        /// ʧܳԴڴ򿪵ںʱ
        /// </summary>
        public virtual DateTime FailedPasswordAttemptWindowStart
        {
            get { return _failedPasswordAttemptWindowStart; }
            set { _failedPasswordAttemptWindowStart = value; }
        }

        /// <summary>
        /// ʾԴ
        /// </summary>
        public virtual int FailedPasswordAnswerAttemptCount
        {
            get { return _failedPasswordAnswerAttemptCount; }
            set { _failedPasswordAnswerAttemptCount = value; }
        }

        /// <summary>
        /// ʾʧܳԴڴ򿪵ںʱ
        /// </summary>
        public virtual DateTime FailedPasswordAnswerAttemptWindowStart
        {
            get { return _failedPasswordAnswerAttemptWindowStart; }
            set { _failedPasswordAnswerAttemptWindowStart = value; }
        }

        /// <summary>
        /// ԶϢ
        /// </summary>
        public virtual string Comment
        {
            get { return _comment; }
            set { _comment = value; }
        }

        /// <summary>
        /// Ӧó
        /// </summary>
        public virtual Application Application
        {
            get { return _application; }
            set { _application = value; }
        }

        public virtual IList Roles
        {
            get { return _roles; }
            set { _roles = value; }
        }

        #endregion 

        #region 캯

        /// <summary>
        /// 
        /// </summary>
        public User()
        {
            this._id = -1;
            this._username = String.Empty;
            this._roles = new ArrayList();
        }

        public User(MembershipUser user)
        {

        }

        #endregion 캯

        #region 

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return this._username;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public override bool Equals(object obj)
        {
            User user = obj as User;

            if (user != null && user.ID == this._id)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public override int GetHashCode()
        {

            return base.GetHashCode();
        }


        #endregion 
    }
}
