﻿using System;
using Guushuuse.SalaryPrj.Security.DomainModel;
using Guushuuse.SalaryPrj.Security.Dao;

namespace Guushuuse.SalaryPrj.Security.Service
{
    /// <summary>
    /// 角色服务接口
    /// </summary>
    public interface IRoleService
    {
        int AddUsersToRoles(string applicationName, string[] usernames, string[] roleNames);
        int CreateRole(string applicationName, string roleName);
        int DeleteRole(string applicationName, string roleName, bool deleteOnlyIfRoleIsEmpty);
        string[] FindUsersInRole(string applicationName, string roleName, string usernameToMatch);
        string[] GetAllRoles(string applicationName);
        Role GetRole(int roleID);
        string[] GetRolesForUser(string applicationName, string username);
        string[] GetUsersInRole(string applicationName, string roleName);
        bool IsUserInRole(string applicationName, string username, string roleName);
        int RemoveUsersFromRoles(string applicationName, string[] usernames, string[] roleNames);
        IRoleDao RoleDao { get; set; }
        bool RoleExists(string applicationName, string roleName);
        IUserDao UserDao { get; set; }
    }
}
