﻿using System;
using System.Collections;
using Guushuuse.SalaryPrj.Security.DomainModel;
using Guushuuse.SalaryPrj.Security.Dao;
using System.Web.Security;

namespace Guushuuse.SalaryPrj.Security.Service
{
    /// <summary>
    /// 用户服务接口
    /// </summary>
    public interface IUserService
    {
        int ChangePasswordQuestionAndAnswer(string applicationName, string username, string newPasswordQuestion, string newPasswordAnswer);
        void CreateUser(User user);
        void DeleteUser(User user);
        int DeleteUser(string applicationName, string username, bool deleteAllRelatedData);
        IList FindUsersByEmail(string applicationName, string emailToMatch, int pageIndex, int pageSize, out int totalRecords);
        IList FindUsersByName(string applicationName, string usernameToMatch, int pageIndex, int pageSize, out int totalRecords);
        IList GetAllUsers(string applicationName, int pageIndex, int pageSize, out long totalRecords);
        int GetNumberOfUsersOnline(string applicationName, int minutesSinceLastInActive, DateTime currentTimeUtc);
        string GetPassword(string applicationName, string username, string passwordAnswer, bool requiresQuestionAndAnswer, int maxInvalidPasswordAttempts, int passwordAttemptWindow, out MembershipPasswordFormat passwordFormat, out int status, DateTime currentTimeUtc);
        User GetUser(int userID);
        User GetUserByName(string applicationName, string username, bool updateLastActivity, DateTime currentTimeUtc);
        User GetUserByName(string applicationName, string username);
        User GetUserByUserID(int userID, bool updateLastActivity, DateTime currentTimeUtc);
        IList GetUsersByEmail(string applicationName, string email);
        int ResetPassword(string applicationName, string username, string newPassword, int maxInvalidPasswordAttempts, int passwordAttemptWindow, string passwordSalt, MembershipPasswordFormat passwordFormat, string passwordAnswer, DateTime currentTimeUtc);
        int UnlockUser(string applicationName, string username);
        int UpdatePassword(string applicationName, string username, string newPassword, string passwordSalt, MembershipPasswordFormat passwordFormat, DateTime currentTimeUtc);
        int UpdateUser(string applicationName, string username, string email, string comment, bool isApproved, DateTime lastLoginDate, DateTime lastActivityDate, bool uniqueEmail);
        void UpdateUser(Guushuuse.SalaryPrj.Security.DomainModel.User user);
        int UpdateUserInfo(string applicationName, string username, bool isPasswordCorrect, int passwordAttemptWindow, int maxInvalidPasswordAttempts, bool updateLastLoginActivityDate, DateTime currentTimeUtc);
        IUserDao UserDao { get; set; }
    }
}
