using System;
using System.Collections.Generic;
using System.Text;
using Spring.Context;
using Spring.Context.Support;

namespace Guushuuse.SalaryPrj.Security.Service
{
    /// <summary>
    /// λ
    /// </summary>
    public class ServiceLocator
    {
        private static IApplicationContext _ctx;

        static ServiceLocator()
        {
            _ctx = ContextRegistry.GetContext();
        }

        public static IApplicationService ApplicationService
        {
            get
            {
                IApplicationService applicationService = _ctx["applicationService"] as IApplicationService;

                return applicationService;
            }
        }      

        public static IRoleService RoleService
        {
            get
            {
                IRoleService roleService = _ctx["roleService"] as IRoleService;

                return roleService;
            }
        }

        public static IUserService UserService
        {
            get
            {
                IUserService userService = _ctx["userService"] as IUserService;

                return userService;
            }
        }
    }
}
