﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class UserRole : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            BindUsers();
            BindRoles();
        }
    }

    private void BindUsers()
    {
        System.Web.Security.MembershipUserCollection users = System.Web.Security.Membership.GetAllUsers();

        lstUsers.DataSource = users;
        lstUsers.DataTextField = "UserName";
        lstUsers.DataValueField = "UserName";
        lstUsers.DataBind();
    }

    private void BindRoles()
    {
        
        chkRoles.Items.Clear();

        string[] roles = System.Web.Security.Roles.GetAllRoles();

        string[] userRoles = System.Web.Security.Roles.GetRolesForUser(lstUsers.SelectedValue);

        foreach (string role in roles)
        {
            ListItem item = new ListItem();
            item.Text = role;
            item.Value = role;

            if (Array.IndexOf(userRoles, role) > -1)
            {
                item.Selected = true;
            }

            chkRoles.Items.Add(item);
        }
    
    }

    protected void lstUsers_SelectedIndexChanged(object sender, EventArgs e)
    {
        BindRoles();
    }

    protected void btnUpdate_Click(object sender, EventArgs e)
    {

        foreach (ListItem item in chkRoles.Items)
        {
            if (item.Selected)
            {
                System.Web.Security.Roles.AddUserToRole(lstUsers.SelectedValue, item.Value);
            }
            else
            {
                System.Web.Security.Roles.RemoveUserFromRole(lstUsers.SelectedValue, item.Value);
            }
        }

    }
}
